.subckt spice_4tap_typ nvdd outp ngnd in en  pcl  gcl  outn  
+ bitp=400p
+ cf0=0
+ cf1=1
+ cf2=0
+ cf3=0
+ inv0=1
+ inv1=0
+ inv2=1
+ inv3=0
+ scale=2.75
+ padcap=2p
+ rt=50


*  Some voltage sources are defined to drive the MacroModel. This uses an E element,
*  which is a VCVS, or voltage controlled voltage source.
*
*  P side input voltage to differential buffer
einp in2 ngnd v='v(in, ngnd)'
*  v(in, ngnd) means the potential difference between nodes in and ngnd
*
*  N side input voltage to differential buffer
einn inn ngnd v='1 - v(in, ngnd)'

*  There are 2 drivers in this macromodel, for both the P side and N side.
*  P side driver subcircuit call
xp nvdd outp ngnd in2 en txpre_2 bitp=bitp 
+ inv0=inv0 inv1=inv1 inv2=inv2 inv3=inv3
+ scale=scale
+ padcap=padcap
+ cf0=cf0
+ cf1=cf1
+ cf2=cf2
+ cf3=cf3
+ rt=rt

*  N side driver subcircuit call
xn nvdd outn ngnd inn en txpre_2 bitp=bitp 
+ inv0=inv0 inv1=inv1 inv2=inv2 inv3=inv3
+ scale=scale
+ padcap=padcap
+ cf0=cf0
+ cf1=cf1
+ cf2=cf2
+ cf3=cf3
+ rt=rt

*  Here is the main single-ended driver subcircuit, called txpre_2.
.subckt txpre_2 nvdd out ngnd in en 
+ bitp=400p
+ inv0=1
+ inv1=0
+ inv2=1
+ inv3=0
+ cf0=0
+ cf1=1
+ cf2=0
+ cf3=0
+ scale=2
+ padcap=2p
+ rt=50



*  Termination resistor and pad capacitance elements.
r nvdd out 'rt'
c out ngnd 'padcap'


*  Here are the subcircuit calls for tap inputs, using subcircuit delayin.
xin0 in0 in ngnd delayin inv=inv0 
xin1 in1 in ngnd delayin inv=inv1 del='bitp'
xin2 in2 in ngnd delayin inv=inv2 del='2 * bitp'
xin3 in3 in ngnd delayin inv=inv3 del='3 * bitp'


*  Here are the subcircuit calls for subcircuit tx, containing the current
*  source used for the taps.
xtx0 nvdd out ngnd in0 en tx scale='scale * cf0'
xtx1 nvdd out ngnd in1 en tx scale='scale * cf1'
xtx2 nvdd out ngnd in2 en tx scale='scale * cf2'
xtx3 nvdd out ngnd in3 en tx scale='scale * cf3'


*  This is the subcircuit definition for tx, the current source for the taps.
.subckt tx nvdd out ngnd in en scale=1
rout2 out2 out 0.0001
rout3 out3 out 0.0001
rout32 out3 ngnd 1e6
cout3 out3 out2 0.1p
rngnd2 ngnd2 ngnd 0.0001
*
*  This G element is the current source used for the taps.
*  It is dependent on the VCCS E element following it.
*
rin2 in in2 0.0002
cin2 in2 ngnd 0.1p
gdn out2 ngnd2 i='scale * v(in2) * v(en) * v(pdn)'
epdn pdn 0 pwl out3 ngnd 
*
*  The data points below describe the VCCS behavior. It is essentially the
*  characteristics of a typical NFET device, which acts as the pulldown for
*  the driver.
*
datapoints vv
0.0	0.0	
0.1	0.008
0.2	0.014	
0.3	0.015	
1.0	0.016	
2.0	0.017	
end vv
.ends tx

*  The delayin subcircuit drives the inputs to the tx subcircuit.
.subckt delayin in1 in ngnd inv=0 del=0
ein2 in2 ngnd v='inv * (1 - v(in,ngnd)) + (1-inv) * v(in,ngnd)'
ein1 in1 ngnd pwl in2 ngnd delay=del
datapoints vv
0 0
1 1
end vv
.ends delayin

.ends txpre_2

.ends spice_4tap_typ

.subckt spice_4tap_min nvdd outp ngnd in en  pcl  gcl  outn  
+ bitp=400p
+ cf0=0
+ cf1=1
+ cf2=0
+ cf3=0
+ inv0=1
+ inv1=0
+ inv2=1
+ inv3=0
+ scale=2.75
+ padcap=2p
+ rt=50


*  Some voltage sources are defined to drive the MacroModel. This uses an E element,
*  which is a VCVS, or voltage controlled voltage source.
*
*  P side input voltage to differential buffer
einp in2 ngnd v='v(in, ngnd)'
*  v(in, ngnd) means the potential difference between nodes in and ngnd
*
*  N side input voltage to differential buffer
einn inn ngnd v='1 - v(in, ngnd)'

*  There are 2 drivers in this macromodel, for both the P side and N side.
*  P side driver subcircuit call
xp nvdd outp ngnd in2 en txpre_2 bitp=bitp 
+ inv0=inv0 inv1=inv1 inv2=inv2 inv3=inv3
+ scale=scale
+ padcap=padcap
+ cf0=cf0
+ cf1=cf1
+ cf2=cf2
+ cf3=cf3
+ rt=rt

*  N side driver subcircuit call
xn nvdd outn ngnd inn en txpre_2 bitp=bitp 
+ inv0=inv0 inv1=inv1 inv2=inv2 inv3=inv3
+ scale=scale
+ padcap=padcap
+ cf0=cf0
+ cf1=cf1
+ cf2=cf2
+ cf3=cf3
+ rt=rt

*  Here is the main single-ended driver subcircuit, called txpre_2.
.subckt txpre_2 nvdd out ngnd in en 
+ bitp=400p
+ inv0=1
+ inv1=0
+ inv2=1
+ inv3=0
+ cf0=0
+ cf1=1
+ cf2=0
+ cf3=0
+ scale=2
+ padcap=2p
+ rt=50



*  Termination resistor and pad capacitance elements.
r nvdd out 'rt'
c out ngnd 'padcap'


*  Here are the subcircuit calls for tap inputs, using subcircuit delayin.
xin0 in0 in ngnd delayin inv=inv0 
xin1 in1 in ngnd delayin inv=inv1 del='bitp'
xin2 in2 in ngnd delayin inv=inv2 del='2 * bitp'
xin3 in3 in ngnd delayin inv=inv3 del='3 * bitp'


*  Here are the subcircuit calls for subcircuit tx, containing the current
*  source used for the taps.
xtx0 nvdd out ngnd in0 en tx scale='scale * cf0'
xtx1 nvdd out ngnd in1 en tx scale='scale * cf1'
xtx2 nvdd out ngnd in2 en tx scale='scale * cf2'
xtx3 nvdd out ngnd in3 en tx scale='scale * cf3'


*  This is the subcircuit definition for tx, the current source for the taps.
.subckt tx nvdd out ngnd in en scale=1
rout2 out2 out 0.0001
rout3 out3 out 0.0001
rout32 out3 ngnd 1e6
cout3 out3 out2 0.1p
rngnd2 ngnd2 ngnd 0.0001
*
*  This G element is the current source used for the taps.
*  It is dependent on the VCCS E element following it.
*
rin2 in in2 0.0002
cin2 in2 ngnd 0.1p
gdn out2 ngnd2 i='scale * v(in2) * v(en) * v(pdn)'
epdn pdn 0 pwl out3 ngnd 
*
*  The data points below describe the VCCS behavior. It is essentially the
*  characteristics of a typical NFET device, which acts as the pulldown for
*  the driver.
*
datapoints vv
0.0	0.0	
0.1	0.007
0.2	0.013	
0.3	0.014	
1.0	0.015	
2.0	0.016	
end vv
.ends tx

*  The delayin subcircuit drives the inputs to the tx subcircuit.
.subckt delayin in1 in ngnd inv=0 del=0
ein2 in2 ngnd v='inv * (1 - v(in,ngnd)) + (1-inv) * v(in,ngnd)'
ein1 in1 ngnd pwl in2 ngnd delay=del
datapoints vv
0 0
1 1
end vv
.ends delayin

.ends txpre_2

.ends spice_4tap_min

.subckt spice_4tap_max nvdd outp ngnd in en  pcl  gcl  outn  
+ bitp=400p
+ cf0=0
+ cf1=1
+ cf2=0
+ cf3=0
+ inv0=1
+ inv1=0
+ inv2=1
+ inv3=0
+ scale=2.75
+ padcap=2p
+ rt=50


*  Some voltage sources are defined to drive the MacroModel. This uses an E element,
*  which is a VCVS, or voltage controlled voltage source.
*
*  P side input voltage to differential buffer
einp in2 ngnd v='v(in, ngnd)'
*  v(in, ngnd) means the potential difference between nodes in and ngnd
*
*  N side input voltage to differential buffer
einn inn ngnd v='1 - v(in, ngnd)'

*  There are 2 drivers in this macromodel, for both the P side and N side.
*  P side driver subcircuit call
xp nvdd outp ngnd in2 en txpre_2 bitp=bitp 
+ inv0=inv0 inv1=inv1 inv2=inv2 inv3=inv3
+ scale=scale
+ padcap=padcap
+ cf0=cf0
+ cf1=cf1
+ cf2=cf2
+ cf3=cf3
+ rt=rt

*  N side driver subcircuit call
xn nvdd outn ngnd inn en txpre_2 bitp=bitp 
+ inv0=inv0 inv1=inv1 inv2=inv2 inv3=inv3
+ scale=scale
+ padcap=padcap
+ cf0=cf0
+ cf1=cf1
+ cf2=cf2
+ cf3=cf3
+ rt=rt

*  Here is the main single-ended driver subcircuit, called txpre_2.
.subckt txpre_2 nvdd out ngnd in en 
+ bitp=400p
+ inv0=1
+ inv1=0
+ inv2=1
+ inv3=0
+ cf0=0
+ cf1=1
+ cf2=0
+ cf3=0
+ scale=2
+ padcap=2p
+ rt=50



*  Termination resistor and pad capacitance elements.
r nvdd out 'rt'
c out ngnd 'padcap'


*  Here are the subcircuit calls for tap inputs, using subcircuit delayin.
xin0 in0 in ngnd delayin inv=inv0 
xin1 in1 in ngnd delayin inv=inv1 del='bitp'
xin2 in2 in ngnd delayin inv=inv2 del='2 * bitp'
xin3 in3 in ngnd delayin inv=inv3 del='3 * bitp'


*  Here are the subcircuit calls for subcircuit tx, containing the current
*  source used for the taps.
xtx0 nvdd out ngnd in0 en tx scale='scale * cf0'
xtx1 nvdd out ngnd in1 en tx scale='scale * cf1'
xtx2 nvdd out ngnd in2 en tx scale='scale * cf2'
xtx3 nvdd out ngnd in3 en tx scale='scale * cf3'


*  This is the subcircuit definition for tx, the current source for the taps.
.subckt tx nvdd out ngnd in en scale=1
rout2 out2 out 0.0001
rout3 out3 out 0.0001
rout32 out3 ngnd 1e6
cout3 out3 out2 0.1p
rngnd2 ngnd2 ngnd 0.0001
*
*  This G element is the current source used for the taps.
*  It is dependent on the VCCS E element following it.
*
rin2 in in2 0.0002
cin2 in2 ngnd 0.1p
gdn out2 ngnd2 i='scale * v(in2) * v(en) * v(pdn)'
epdn pdn 0 pwl out3 ngnd 
*
*  The data points below describe the VCCS behavior. It is essentially the
*  characteristics of a typical NFET device, which acts as the pulldown for
*  the driver.
*
datapoints vv
0.0	0.0	
0.1	0.009
0.2	0.015	
0.3	0.016	
1.0	0.017	
2.0	0.018	
end vv
.ends tx

*  The delayin subcircuit drives the inputs to the tx subcircuit.
.subckt delayin in1 in ngnd inv=0 del=0
ein2 in2 ngnd v='inv * (1 - v(in,ngnd)) + (1-inv) * v(in,ngnd)'
ein1 in1 ngnd pwl in2 ngnd delay=del
datapoints vv
0 0
1 1
end vv
.ends delayin

.ends txpre_2

.ends spice_4tap_max

